.model tiny
.286

ORG	100h

fontofs=0fa6eh
fontseg=0f000h

@es=26h
@cs=2eh
@fs=64h
@gs=65h

_op macro op,segment,
 db segment
 op
endm

_ramp macro _r1, _g1, _b1, _r2, _g2, _b2, __src, __dst
  mov [r1], _r1
  mov [g1], _g1
  mov [b1], _b1

  mov [r2], _r2
  mov [g2], _g2
  mov [b2], _b2

  mov [_src], __src
  mov [_dst], __dst

  call ramp
endm


code segment
	assume cs:code,ds:code,es:code,ss:code
	org 100h

.386
MAIN	PROC NEAR
 mov	ax,13h
 int	10h

 mov    bp,6000h	;6000h+7000h water segz,bp
			;6000h xor 1000h = 7000h

 mov	al,0
 mov	es,bp
 mov	cx,-1
 xor	di,di
 rep	stosb

 xor	bp,1000h		;switch
 mov	es,bp
 dec	cx
 xor	di,di
 rep	stosb

;set up palette
_ramp  0, 0, 0,   63, 0, 0,   0, 191
_ramp 63, 0, 0,   63,63, 0, 192, 225
_ramp 63,63, 0,   63,63,63, 225, 255

xor ax,ax
int 33h

keypressed:
 xor bp,1000h
 mov es,bp

   lea bx,_txt
   mov cx,8           ;txt len
   mov di,320*80+40
   call _putstr

 mov ax,3
 int 33h
 shr cx,1

@rainy:
   mov ax,320
   mul dx
   add ax,cx
   cmp ax,64000-960
   jae @@noput
     mov di,ax
     mov ax,-1
     mov es:[di],ax
     mov es:[di+320],ax
  @@noput:

@noset:
 call	@advance_water
 call	@show_water

 in al,60h
 dec al
 jnz keypressed

 mov ax,03h
 int 10h
 ret
MAIN	ENDP

@advance_water:
 push   ds

 mov	ax,bp
 mov	bx,bp
 xor	bx,1000h
 mov	ds,ax
 mov	es,bx

 mov	di,320
 xor	dx,dx
@@adv_loop:
    xor cx,cx
    xor ax,ax
    mov cl,[di-321]
    mov al,[di-320]
    add ax,cx
    mov cl,[di-319]
    add ax,cx
    mov cl,[di-1]
    add ax,cx
    mov cl,[di+1]
    add ax,cx
    mov cl,[di+319]
    add ax,cx
    mov cl,[di+320]
    add ax,cx
    mov cl,[di+321]
    add ax,cx
    add ax,dx
    shr ax,3
    jz @zero
      dec al
   @zero:



    mov es:[di-320],al
  inc	di
  cmp   di, 64000-320
  jne	@@adv_loop
  pop	ds
ret

@show_water:
 push   ds

;comment /*
 mov dx,03dah
 in al,dx
 test al,8
 jz $-3
 in al,dx
 test al,8
 jnz $-3
;/*

 mov	ds,bp
 push	0a000h
 pop	es
 mov    cx,64000/2
 xor    di,di
 xor    si,si
 rep    movsw

@@done:
 pop ds
ret

@rand:
 in ax,40h
 xor ax,randseed
 mov randseed,ax
ret


;str at [bx]
;len in cx
;screenpos in di
;zoom only really works for 4x4 pixels heh
zoom=4

_putstr:
 push ebp
 push fontseg
 pop fs


@@strloop:
 movzx si,byte ptr cs:[bx]
 inc bx
 shl si,3
 add si,fontofs

    mov dh,8
  @@rowloop:
      _op lodsb,@fs
      mov dl,8
    @@colloop:
        shl al,1
        push ax
        jnc @@skip
          mov ebp,-1
       @@plot:
          i=0
          rept zoom
            call @rand
            or al,7
            and al,15
            add byte ptr es:[di+(320*i)], al
            add byte ptr es:[di+(320*i)+1], al
            add byte ptr es:[di+(320*i)+2], al
            add byte ptr es:[di+(320*i)+3], al
            i=i+1
          endm
        @@skip:
        pop ax
      add di,(1*zoom)
      dec dl
      jnz @@colloop

   add di,(320*zoom)-(8*zoom)
   dec dh
   jnz @@rowloop

 add di,-(320*8*zoom)+(8*zoom)

 dec cx
 jnz @@strloop
pop ebp
ret


ramp:
  mov dx,03c8h
  mov ax,[_src]
  out dx,al

  mov cx,[_dst]
  sub cx,[_src]

  jz @@single

  mov dx,256
  mov ax,[r2]
  sub ax,[r1]
  imul dx
  idiv cx
  mov [ur],ax

  mov dx,256
  mov ax,[g2]
  sub ax,[g1]
  imul dx
  idiv cx
  mov [ug],ax

  mov dx,256
  mov ax,[b2]
  sub ax,[b1]
  imul dx
  idiv cx
  mov [ub],ax

 @@single:
  mov ax,[r1]
  mov bx,[g1]
  mov cx,[b1]
  shl ax,8
  shl bx,8
  shl cx,8

  mov dx,03c9h

  mov di,[_src]
 @ramploop:
  mov si,ax

  mov al,ah
  out dx,al
  mov al,bh
  out dx,al
  mov al,ch
  out dx,al

  mov ax,si

  add ax,[ur]
  add bx,[ug]
  add cx,[ub]

  inc di
  cmp di,[_dst]
  jle @ramploop
ret

_txt db 7,'Tribes',7

_dst dw ?
_src dw ?

r1 dw ?
g1 dw ?
b1 dw ?

r2 dw ?
g2 dw ?
b2 dw ?

ur dw ?
ug dw ?
ub dw ?

randseed dw ?


code	ends
	end main